<?php

namespace backend\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\models\MasterKompetensi;

/**
 * MasterKompetensiSearch represents the model behind the search form of `backend\models\MasterKompetensi`.
 */
class MasterKompetensiSearch extends MasterKompetensi
{
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['SKEMA_UUID', 'MASKOM_UUID', 'MASKOM_KODE', 'MASKOM_JUDUL', 'CREATED', 'USERNAME'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     * @param string|null $formName Form name to be used into `->load()` method.
     *
     * @return ActiveDataProvider
     */
    public function search($params, $formName = null)
    {
        $query = MasterKompetensi::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params, $formName);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'CREATED' => $this->CREATED,
        ]);

        $query->andFilterWhere(['like', 'SKEMA_UUID', $this->SKEMA_UUID])
            ->andFilterWhere(['like', 'MASKOM_UUID', $this->MASKOM_UUID])
            ->andFilterWhere(['like', 'MASKOM_KODE', $this->MASKOM_KODE])
            ->andFilterWhere(['like', 'MASKOM_JUDUL', $this->MASKOM_JUDUL])
            ->andFilterWhere(['like', 'USERNAME', $this->USERNAME]);

        return $dataProvider;
    }
}
